# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.Device do
  @moduledoc """
  An Android device registered for zero-touch enrollment.

  ## Attributes

  - claims ([DeviceClaim]): Output only. The provisioning claims for a device. Devices claimed for zero-touch enrollment have a claim with the type &#x60;SECTION_TYPE_ZERO_TOUCH&#x60;. Call &#x60;partners.devices.unclaim&#x60; or &#x60;partners.devices.unclaimAsync&#x60; to remove the device from zero-touch enrollment. Defaults to: `null`.
  - configuration (String.t): Not available to resellers. Defaults to: `null`.
  - deviceId (String.t): Output only. The ID of the device. Assigned by the server. Defaults to: `null`.
  - deviceIdentifier (DeviceIdentifier): The hardware IDs that identify a manufactured device. To learn more, read [Identifiers](/zero-touch/guides/identifiers). Defaults to: `null`.
  - deviceMetadata (DeviceMetadata): The metadata attached to the device. Structured as key-value pairs. To learn more, read [Device metadata](/zero-touch/guides/metadata). Defaults to: `null`.
  - name (String.t): Output only. The API resource name in the format &#x60;partners/[PARTNER_ID]/devices/[DEVICE_ID]&#x60;. Assigned by the server. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :claims => list(GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim.t()),
          :configuration => any(),
          :deviceId => any(),
          :deviceIdentifier => GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier.t(),
          :deviceMetadata => GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceMetadata.t(),
          :name => any()
        }

  field(:claims, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim, type: :list)
  field(:configuration)
  field(:deviceId)
  field(:deviceIdentifier, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier)
  field(:deviceMetadata, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceMetadata)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.Device do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.Device.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.Device do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
