# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim do
  @moduledoc """
  A record of a device claimed by a reseller for a customer. Devices claimed for zero-touch enrollment have a claim with the type &#x60;SECTION_TYPE_ZERO_TOUCH&#x60;. To learn more, read [Claim devices for customers](/zero-touch/guides/how-it-works#claim).

  ## Attributes

  - ownerCompanyId (String.t): The ID of the Customer that purchased the device. Defaults to: `null`.
  - resellerId (String.t): The ID of the reseller that claimed the device. Defaults to: `null`.
  - sectionType (String.t): Output only. The type of claim made on the device. Defaults to: `null`.
    - Enum - one of [SECTION_TYPE_UNSPECIFIED, SECTION_TYPE_SIM_LOCK, SECTION_TYPE_ZERO_TOUCH]
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ownerCompanyId => any(),
          :resellerId => any(),
          :sectionType => any()
        }

  field(:ownerCompanyId)
  field(:resellerId)
  field(:sectionType)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceClaim do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
