# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier do
  @moduledoc """
  Encapsulates hardware and product IDs to identify a manufactured device. To understand requirements on identifier sets, read [Identifiers](/zero-touch/guides/identifiers).

  ## Attributes

  - imei (String.t): The device’s IMEI number. Validated on input. Defaults to: `null`.
  - manufacturer (String.t): The device manufacturer’s name. Matches the device&#39;s built-in value returned from &#x60;android.os.Build.MANUFACTURER&#x60;. Allowed values are listed in [manufacturers](/zero-touch/resources/manufacturer-names#manufacturers-names). Defaults to: `null`.
  - meid (String.t): The device’s MEID number. Defaults to: `null`.
  - model (String.t): The device model&#39;s name. Matches the device&#39;s built-in value returned from &#x60;android.os.Build.MODEL&#x60;. Allowed values are listed in [models](/zero-touch/resources/manufacturer-names#model-names). Defaults to: `null`.
  - serialNumber (String.t): The manufacturer&#39;s serial number for the device. This value might not be unique across different device models. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :imei => any(),
          :manufacturer => any(),
          :meid => any(),
          :model => any(),
          :serialNumber => any()
        }

  field(:imei)
  field(:manufacturer)
  field(:meid)
  field(:model)
  field(:serialNumber)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.DeviceIdentifier do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
