# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.Operation do
  @moduledoc """
  This resource represents a long-running operation that is the result of a network API call.

  ## Attributes

  - done (boolean()): If the value is &#x60;false&#x60;, it means the operation is still in progress. If &#x60;true&#x60;, the operation is completed, and either &#x60;error&#x60; or &#x60;response&#x60; is available. Defaults to: `null`.
  - error (Status): This field will always be not set if the operation is created by &#x60;claimAsync&#x60;, &#x60;unclaimAsync&#x60;, or &#x60;updateMetadataAsync&#x60;. In this case, error information for each device is set in &#x60;response.perDeviceStatus.result.status&#x60;. Defaults to: `null`.
  - metadata (%{optional(String.t) &#x3D;&gt; String.t}): This field will contain a &#x60;DevicesLongRunningOperationMetadata&#x60; object if the operation is created by &#x60;claimAsync&#x60;, &#x60;unclaimAsync&#x60;, or &#x60;updateMetadataAsync&#x60;. Defaults to: `null`.
  - name (String.t): The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the &#x60;name&#x60; should have the format of &#x60;operations/some/unique/name&#x60;. Defaults to: `null`.
  - response (%{optional(String.t) &#x3D;&gt; String.t}): This field will contain a &#x60;DevicesLongRunningOperationResponse&#x60; object if the operation is created by &#x60;claimAsync&#x60;, &#x60;unclaimAsync&#x60;, or &#x60;updateMetadataAsync&#x60;. Defaults to: `null`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :done => any(),
          :error => GoogleApi.AndroidDeviceProvisioning.V1.Model.Status.t(),
          :metadata => map(),
          :name => any(),
          :response => map()
        }

  field(:done)
  field(:error, as: GoogleApi.AndroidDeviceProvisioning.V1.Model.Status)
  field(:metadata, type: :map)
  field(:name)
  field(:response, type: :map)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.Operation do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.Operation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.Operation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
