# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AndroidDeviceProvisioning.V1.Model.PerDeviceStatusInBatch do
  @moduledoc """
  Captures the processing status for each device in the operation.

  ## Attributes

  - deviceId (String.t): If processing succeeds, the device ID of the device. Defaults to: `null`.
  - errorIdentifier (String.t): If processing fails, the error type. Defaults to: `null`.
  - errorMessage (String.t): If processing fails, a developer message explaining what went wrong. Defaults to: `null`.
  - status (String.t): The result status of the device after processing. Defaults to: `null`.
    - Enum - one of [SINGLE_DEVICE_STATUS_UNSPECIFIED, SINGLE_DEVICE_STATUS_UNKNOWN_ERROR, SINGLE_DEVICE_STATUS_OTHER_ERROR, SINGLE_DEVICE_STATUS_SUCCESS, SINGLE_DEVICE_STATUS_PERMISSION_DENIED, SINGLE_DEVICE_STATUS_INVALID_DEVICE_IDENTIFIER, SINGLE_DEVICE_STATUS_INVALID_SECTION_TYPE, SINGLE_DEVICE_STATUS_SECTION_NOT_YOURS]
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deviceId => any(),
          :errorIdentifier => any(),
          :errorMessage => any(),
          :status => any()
        }

  field(:deviceId)
  field(:errorIdentifier)
  field(:errorMessage)
  field(:status)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.PerDeviceStatusInBatch do
  def decode(value, options) do
    GoogleApi.AndroidDeviceProvisioning.V1.Model.PerDeviceStatusInBatch.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidDeviceProvisioning.V1.Model.PerDeviceStatusInBatch do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
